<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfOzellestirmeItem ArrayType
 * Meta informations extracted from the WSDL
 * - nillable: true
 * - type: tns:ArrayOfOzellestirmeItem
 * @subpackage Arrays
 */
class ArrayOfOzellestirmeItem extends AbstractStructArrayBase
{
    /**
     * The OzellestirmeItem
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\OzellestirmeItem[]
     */
    public $OzellestirmeItem;
    /**
     * Constructor method for ArrayOfOzellestirmeItem
     * @uses ArrayOfOzellestirmeItem::setOzellestirmeItem()
     * @param \StructType\OzellestirmeItem[] $ozellestirmeItem
     */
    public function __construct(array $ozellestirmeItem = array())
    {
        $this
            ->setOzellestirmeItem($ozellestirmeItem);
    }
    /**
     * Get OzellestirmeItem value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\OzellestirmeItem[]|null
     */
    public function getOzellestirmeItem()
    {
        return isset($this->OzellestirmeItem) ? $this->OzellestirmeItem : null;
    }
    /**
     * Set OzellestirmeItem value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\OzellestirmeItem[] $ozellestirmeItem
     * @return \ArrayType\ArrayOfOzellestirmeItem
     */
    public function setOzellestirmeItem(array $ozellestirmeItem = array())
    {
        foreach ($ozellestirmeItem as $arrayOfOzellestirmeItemOzellestirmeItemItem) {
            // validation for constraint: itemType
            if (!$arrayOfOzellestirmeItemOzellestirmeItemItem instanceof \StructType\OzellestirmeItem) {
                throw new \InvalidArgumentException(sprintf('The OzellestirmeItem property can only contain items of \StructType\OzellestirmeItem, "%s" given', is_object($arrayOfOzellestirmeItemOzellestirmeItemItem) ? get_class($arrayOfOzellestirmeItemOzellestirmeItemItem) : gettype($arrayOfOzellestirmeItemOzellestirmeItemItem)), __LINE__);
            }
        }
        if (is_null($ozellestirmeItem) || (is_array($ozellestirmeItem) && empty($ozellestirmeItem))) {
            unset($this->OzellestirmeItem);
        } else {
            $this->OzellestirmeItem = $ozellestirmeItem;
        }
        return $this;
    }
    /**
     * Add item to OzellestirmeItem value
     * @throws \InvalidArgumentException
     * @param \StructType\OzellestirmeItem $item
     * @return \ArrayType\ArrayOfOzellestirmeItem
     */
    public function addToOzellestirmeItem(\StructType\OzellestirmeItem $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\OzellestirmeItem) {
            throw new \InvalidArgumentException(sprintf('The OzellestirmeItem property can only contain items of \StructType\OzellestirmeItem, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->OzellestirmeItem[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\OzellestirmeItem|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\OzellestirmeItem|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\OzellestirmeItem|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\OzellestirmeItem|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\OzellestirmeItem|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string OzellestirmeItem
     */
    public function getAttributeName()
    {
        return 'OzellestirmeItem';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfOzellestirmeItem
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
